/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.gui.modalites;

import java.awt.BorderLayout;
import java.util.Date;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.common.utilities.CocktailConstantes;
import org.cocktail.application.common.utilities.CocktailFormats;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.mangue.modele.mangue.modalites.EOCrctDetail;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class CRCTView extends javax.swing.JPanel {

	private static final long serialVersionUID = -7770031412248058797L;
	protected EODisplayGroup eod;
	protected ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;

    /** Creates new form TemplateJPanel */
    public CRCTView(EODisplayGroup eod) {
                
    	this.eod = eod;
        initComponents();
        initGui();
        
    }

	/** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        tfCommentaires = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        tfLibelleOrigine = new javax.swing.JTextField();
        btnGetOrigine = new javax.swing.JButton();
        btnDelCnu = new javax.swing.JButton();
        btnGetCnu = new javax.swing.JButton();
        tfLibelleCnu = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        tfDateArreteAnnulation = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        tfNoArreteAnnulation = new javax.swing.JTextField();
        checkCongeFractionne = new javax.swing.JCheckBox();
        viewTableFractionnement = new javax.swing.JPanel();
        btnAddDetail = new javax.swing.JButton();
        btnDelDetail = new javax.swing.JButton();

        tfCommentaires.setColumns(20);
        tfCommentaires.setRows(5);
        jScrollPane1.setViewportView(tfCommentaires);

        jLabel1.setText("Commentaires :");

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("Origine de la demande :");

        tfLibelleOrigine.setEditable(false);

        btnGetOrigine.setToolTipText("Sélection du motif du congé sans traitement");

        btnDelCnu.setToolTipText("Sélection du motif du congé sans traitement");

        btnGetCnu.setToolTipText("Sélection du motif du congé sans traitement");

        tfLibelleCnu.setEditable(false);

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel3.setText("CNU");

        jLabel20.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel20.setText("Annularion Arrêté :      Date :");

        tfDateArreteAnnulation.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfDateArreteAnnulation.setToolTipText("");

        jLabel21.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel21.setText("No Arrêté");

        tfNoArreteAnnulation.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfNoArreteAnnulation.setToolTipText("");

        checkCongeFractionne.setText("Congé Fractionné");

        viewTableFractionnement.setLayout(new java.awt.BorderLayout());

        btnAddDetail.setToolTipText("Sélection du motif du congé sans traitement");

        btnDelDetail.setToolTipText("Sélection du motif du congé sans traitement");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 587, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 143, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(tfLibelleOrigine)
                                    .add(tfLibelleCnu, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 356, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                        .add(tfDateArreteAnnulation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 91, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(jLabel21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 71, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                        .add(tfNoArreteAnnulation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 116, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(layout.createSequentialGroup()
                                        .add(btnGetCnu)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(btnDelCnu))
                                    .add(btnGetOrigine)))))
                    .add(layout.createSequentialGroup()
                        .add(19, 19, 19)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel20)
                            .add(layout.createSequentialGroup()
                                .add(checkCongeFractionne)
                                .add(62, 62, 62)
                                .add(viewTableFractionnement, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 278, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(btnDelDetail, 0, 0, Short.MAX_VALUE)
                                    .add(btnAddDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(24, 24, 24)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(tfLibelleOrigine, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(btnGetOrigine, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(tfLibelleCnu, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(btnGetCnu, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnDelCnu, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel20)
                    .add(tfDateArreteAnnulation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel21)
                    .add(tfNoArreteAnnulation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(checkCongeFractionne)
                            .add(layout.createSequentialGroup()
                                .add(32, 32, 32)
                                .add(btnAddDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnDelDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .add(37, 37, 37))
                    .add(viewTableFractionnement, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 58, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(37, 37, 37))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddDetail;
    private javax.swing.JButton btnDelCnu;
    private javax.swing.JButton btnDelDetail;
    private javax.swing.JButton btnGetCnu;
    private javax.swing.JButton btnGetOrigine;
    private javax.swing.JCheckBox checkCongeFractionne;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea tfCommentaires;
    protected javax.swing.JTextField tfDateArreteAnnulation;
    private javax.swing.JTextField tfLibelleCnu;
    private javax.swing.JTextField tfLibelleOrigine;
    protected javax.swing.JTextField tfNoArreteAnnulation;
    private javax.swing.JPanel viewTableFractionnement;
    // End of variables declaration//GEN-END:variables

    
    private void initGui() {

    	btnGetOrigine.setIcon(CocktailIcones.ICON_SELECT_16);

    	btnDelCnu.setIcon(CocktailIcones.ICON_DELETE);
    	btnGetCnu.setIcon(CocktailIcones.ICON_SELECT_16);
    	btnAddDetail.setIcon(CocktailIcones.ICON_ADD);
    	btnDelDetail.setIcon(CocktailIcones.ICON_DELETE);
    	
    	
		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eod, EOCrctDetail.DATE_DEBUT_KEY, "Début", 100);
    	col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);    		
		col.setColumnClass(Date.class);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOCrctDetail.DATE_FIN_KEY, "Fin", 100);
    	col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);    		
		col.setColumnClass(Date.class);
    	myCols.add(col);

		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		//myEOTable.addListener(myListenerContrat);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

//		myEOTable.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTable.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableFractionnement.setLayout(new BorderLayout());
		viewTableFractionnement.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableFractionnement.removeAll();
		viewTableFractionnement.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

    }

	public javax.swing.JButton getBtnDelCnu() {
		return btnDelCnu;
	}

	public void setBtnDelCnu(javax.swing.JButton btnDelCnu) {
		this.btnDelCnu = btnDelCnu;
	}

	public javax.swing.JButton getBtnGetCnu() {
		return btnGetCnu;
	}

	public void setBtnGetCnu(javax.swing.JButton btnGetCnu) {
		this.btnGetCnu = btnGetCnu;
	}

	public javax.swing.JButton getBtnGetOrigine() {
		return btnGetOrigine;
	}

	public void setBtnGetOrigine(javax.swing.JButton btnGetOrigine) {
		this.btnGetOrigine = btnGetOrigine;
	}

	public javax.swing.JCheckBox getCheckCongeFractionne() {
		return checkCongeFractionne;
	}

	public void setCheckCongeFractionne(javax.swing.JCheckBox checkCongeFractionne) {
		this.checkCongeFractionne = checkCongeFractionne;
	}

	public javax.swing.JTextArea getTfCommentaires() {
		return tfCommentaires;
	}

	public void setTfCommentaires(javax.swing.JTextArea tfCommentaires) {
		this.tfCommentaires = tfCommentaires;
	}

	public javax.swing.JTextField getTfDateArreteAnnulation() {
		return tfDateArreteAnnulation;
	}

	public void setTfDateArreteAnnulation(
			javax.swing.JTextField tfDateArreteAnnulation) {
		this.tfDateArreteAnnulation = tfDateArreteAnnulation;
	}

	public javax.swing.JTextField getTfLibelleCnu() {
		return tfLibelleCnu;
	}

	public void setTfLibelleCnu(javax.swing.JTextField tfLibelleCnu) {
		this.tfLibelleCnu = tfLibelleCnu;
	}

	public javax.swing.JTextField getTfLibelleOrigine() {
		return tfLibelleOrigine;
	}

	public void setTfLibelleOrigine(javax.swing.JTextField tfLibelleOrigine) {
		this.tfLibelleOrigine = tfLibelleOrigine;
	}

	public javax.swing.JTextField getTfNoArreteAnnulation() {
		return tfNoArreteAnnulation;
	}

	public void setTfNoArreteAnnulation(javax.swing.JTextField tfNoArreteAnnulation) {
		this.tfNoArreteAnnulation = tfNoArreteAnnulation;
	}

	public javax.swing.JPanel getViewTableFractionnement() {
		return viewTableFractionnement;
	}

	public void setViewTableFractionnement(
			javax.swing.JPanel viewTableFractionnement) {
		this.viewTableFractionnement = viewTableFractionnement;
	}

	public javax.swing.JButton getBtnAddDetail() {
		return btnAddDetail;
	}

	public void setBtnAddDetail(javax.swing.JButton btnAddDetail) {
		this.btnAddDetail = btnAddDetail;
	}

	public javax.swing.JButton getBtnDelDetail() {
		return btnDelDetail;
	}

	public void setBtnDelDetail(javax.swing.JButton btnDelDetail) {
		this.btnDelDetail = btnDelDetail;
	}

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}
    
    

    
}
